package com.gic.haoban.manage.web.controller;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.haoban.base.api.common.pojo.dto.WebLoginDTO;
import com.gic.haoban.common.utils.AuthWebRequestUtil;
import com.gic.haoban.manage.api.dto.qdto.role.HaobanRoleQDTO;
import com.gic.haoban.manage.api.dto.role.HaobanMenuDTO;
import com.gic.haoban.manage.api.service.role.HaobanMenuApiService;
import com.gic.haoban.manage.api.service.role.HaobanRoleApiService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author xuwenqian
 * @date 2022/9/13 3:07 下午
 */
@RequestMapping("role")
@RestController
public class HaobanRoleController {

    @Autowired
    private HaobanMenuApiService haobanMenuApiService;
    @Autowired
    private HaobanRoleApiService haobanRoleApiService;

    /**
     * 获取菜单树
     * @return
     */
    @RequestMapping("/getMenuTreeList")
    private RestResponse<List<HaobanMenuDTO>> getMenuTreeList() {
        ServiceResponse<List<HaobanMenuDTO>> serviceMenuTreeList = haobanMenuApiService.getMenuTreeList();
        return RestResponse.successResult(serviceMenuTreeList.getResult());
    }

    /**
     * 修改
     * @param haobanRoleQDTO
     * @return
     */
    @RequestMapping(value = "/edit",method = RequestMethod.POST)
    private RestResponse edit(@RequestBody HaobanRoleQDTO haobanRoleQDTO) {
        WebLoginDTO login = AuthWebRequestUtil.getLoginUser();
        return RestResponse.successResult(haobanRoleApiService.edit(haobanRoleQDTO,login));
    }

    /**
     * 根据角色查询菜单
     * @param roleId
     * @return
     */
    @RequestMapping(value = "/queryMenuByRoleId",method = RequestMethod.GET)
    private RestResponse queryMenuByRoleId(Long roleId) {
        WebLoginDTO login = AuthWebRequestUtil.getLoginUser();
        ServiceResponse serviceResponse = haobanRoleApiService.getByWxEnterpriseIdAndRoleId(login.getWxEnterpriseId(), roleId);
        return RestResponse.successResult(serviceResponse.getResult());
    }


}
